//---------------------------------------------------------------------------

#include <vcl.h>
#include <clx.h>
#pragma hdrstop

#include "Unit1.h"
#include "complex.h"
#include <sstream>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
ComplexNumber *C1,*C2;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
C1 = new ComplexNumber();
C2 = new ComplexNumber();
refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{

AnsiString oper = Opers->Items->Strings[Opers->ItemIndex];

ComplexNumber *C = 0;
bool *test = 0;

if (oper == "+")
	C = new ComplexNumber( *C1 + *C2 );
else if (oper == "-")
	C = new ComplexNumber( *C1 - *C2 );
else if (oper == "*")
	C = new ComplexNumber( *C1 * *C2 );
else if (oper == "/")
	C = new ComplexNumber( *C1 / *C2 );
else if (oper == "+=")
	*C1 += *C2;
else if (oper == "-=")
	*C1 -= *C2;
else if (oper == "*=")
	*C1 *= *C2;
else if (oper == "/=")
	*C1 /= *C2;
else if (oper == "++")
	(*C1)++;
else if (oper == "--")
	(*C1)--;
else if (oper == "==")
	test = new bool( *C1 == *C2 );
else if (oper == ">")
	test = new bool( *C1 > *C2 );
else if (oper == "<")
	test = new bool( *C1 < *C2 );
else if (oper == ">=")
	test = new bool( *C1 >= *C2 );
else if (oper == "<=")
	test = new bool( *C1 <= *C2 );

if (C) {
	string t;
	t = "(" + C1->toString() + ") " + oper.c_str() +
		" (" + C2->toString() + ") = " + C->toString();
	Log->Lines->Add( t.c_str() );
	delete C;
} else if (test) {
	string t;
	t = "(" + C1->toString() + ") " + oper.c_str() +
		" (" + C2->toString() + ") = " + (*test?"TRUE":"FALSE");
	Log->Lines->Add( t.c_str() );
	delete test;
}
refresh();
}
//---------------------------------------------------------------------------


TForm1::refresh()
{
	X1->Text = C1->Re();
	Y1->Text = C1->Im();
	X2->Text = C2->Re();
	Y2->Text = C2->Im();
}
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	delete C1;
	C1 = new ComplexNumber( X1->Text.ToDouble(), Y1->Text.ToDouble() );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	delete C2;
	C2 = new ComplexNumber( X2->Text.ToDouble(), Y2->Text.ToDouble() );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
Log->Lines->Add( "Absolute value = " + AnsiString( C1->abs() ) );
}
//---------------------------------------------------------------------------
