//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "Unit2.h"
#include <ComCtrls.hpp>
#include <vector>
//---------------------------------------------------------------------------

using namespace std;

class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TColorBox *ColorBox1;
	TButton *Button1;
	TPaintBox *PaintBox;
	TButton *Button2;
	TPanel *Panel2;
	TTrackBar *TrackBar1;
	TTrackBar *TrackBar2;
	TTrackBar *TrackBar3;
	TButton *Button3;
	TButton *Button4;
	void __fastcall Button1Click(TObject *Sender);
	void __fastcall Button2Click(TObject *Sender);
	void __fastcall PaintBoxMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall Button3Click(TObject *Sender);
	void __fastcall Button4Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
	vector<grapp::Shape*> shapes;
	unsigned int x;
	unsigned int y;
	__fastcall TForm1(TComponent* Owner);

	void redraw() {

		TCanvas * dc = PaintBox->Canvas;

		vector<grapp::Shape*>::iterator i;
		for (i=shapes.begin();i!=shapes.end();i++) {
			(*i)->draw( *dc );
		}

	}

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
