//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "List.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
List * list;
Element * edited;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{

Name->Text	= "";
Age->Text	= "";
Score->Text	= "";
list = new List;
elem_init( list );
edited = 0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{

Element * elem;

if (edited)
	elem = edited;
else
	elem = new Element;

elem->name	= Name->Text;
elem->age	= Age->Text.IsEmpty()?0:StrToInt( Age->Text );
elem->score = Score->Text.IsEmpty()?0:Score->Text.ToDouble();
elem->time 	= Now();

Name->Text = "";
Age->Text  = "";
Score->Text= "";

if (!edited)
	elem_add( list, elem );
else {
	Button1->Caption = "Add";
	Button2->Enabled = false;
	edited = 0;
}

refreshList();


}
//---------------------------------------------------------------------------


TForm1::refreshList()
{

View->Items->Clear();

Element * elem = list->first;

while (elem) {

	TListItem * item = View->Items->Add();
	item->Caption = elem->name;
	item->SubItems->Add( elem->age );
	item->SubItems->Add( elem->score );
	item->SubItems->Add( DateTimeToStr( elem->time ) );

	elem = elem->next;

}

}
void __fastcall TForm1::ViewDblClick(TObject *Sender)
{

if (!View->Selected) return;

edited = elem_byindex( list, View->Selected->Index );
Button1->Caption = "Modify";
Button2->Enabled = true;

Name->Text	= edited->name;
Age->Text	= edited->age;
Score->Text	= edited->score;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{

elem_del( list, edited );
edited = 0;
Button1->Caption = "Add";
Button2->Enabled = false;

Name->Text	= "";
Age->Text	= "";
Score->Text	= "";

refreshList();


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{

elem_clear( list );
refreshList();

}
//---------------------------------------------------------------------------

